<template>
    <div class="register section">
        <div class="container">
            <form
                class="form-block auth-form"
                @submit.prevent="userLogin"
                :class="[statusForm ? 'blocking' : '']"
            >
                <div class="form-block__header">{{ $t('form.entrance') }}</div>

                <div class="form-block__content">
                    <div class="form-block__wrapper-input">
                        <input
                            type="text"
                            name="EMAIL"
                            class="input default"
                            v-model="email"
                            v-validate="'required|email'"
                            :placeholder="holder.email"
                            @focus="holder.email = ''"
                            @blur="holder.email = 'E-mail'"
                            :disabled="statusForm"
                            data-vv-validate-on="blur"
                        >
                        <div class="error-text">
                            {{errors.first('EMAIL')}}
                        </div>
                    </div>
                    <div class="form-block__wrapper-input">
                        <input
                            type="password"
                            name="PASSWORD"
                            class="input default"
                            v-model="password"
                            v-validate="'required'"
                            :placeholder="holder.password"
                            @focus="holder.password = ''"
                            @blur="holder.password = 'Пароль'"
                            :disabled="statusForm"
                            data-vv-validate-on="blur"
                        >
                        <div class="error-text">
                            {{errors.first('PASSWORD')}}
                        </div>
                    </div>

                    <div class="form-block__restore center">
                        <a @click="$router.push('/password-recovery')">
                            {{ $t('form.passwordRecovery') }}
                        </a>
                    </div>

                    <input
                        type="submit"
                        :value="$t('header.entrance')"
                        class="btn btn-primary"
                    >

                    <div class="form-block__authentication hr">
                        {{ $t('form.firstStep') }}? <a @click="$router.push('/registration')">{{ $t('form.registration') }}</a>
                    </div>

                    <div class="form-block__partner">
                        <p>{{ $t('form.entranceByPartner') }}</p>
                        <div class="form-block__section-partner">
                            <a
                                class="form-block__partner-button"
                                @click="$router.push('/partner/nris')
                                ">
                                <BaseSvgIcon
                                    id="n-ris"
                                    width="48"
                                    height="18"
                                    viewBox="0 0 48 18"
                                    class="form-block__partner-icon"
                                />
                            </a>
                            <a
                                class="form-block__partner-button"
                                @click="$router.push('/partner/sp')"
                            >
                                <BaseSvgIcon
                                    id="ip"
                                    width="38" height="19"
                                    viewBox="0 0 38 19"
                                    class="form-block__partner-icon"
                                />
                            </a>
                            <a
                                class="form-block__partner-button"
                                @click="$router.push('/partner/zaycev')"
                            >
                                <BaseSvgIcon
                                    id="zaicev"
                                    width="102"
                                    height="15"
                                    viewBox="0 0 102 15"
                                    class="form-block__partner-icon"
                                />
                            </a>
                            <a
                                class="form-block__partner-button"
                                @click="$router.push('/partner/fonmix')"
                            >
                                <BaseSvgIcon
                                    id="fonmix"
                                    width="89"
                                    height="30"
                                    viewBox="0 0 89 30"
                                    class="form-block__partner-icon"
                                />
                            </a>
                        </div>
                        <a
                            class="form-block__partner-button"
                            @click="$router.push('/partner/ipchain')"
                        >
                            <BaseSvgIcon
                                id="ip-chain"
                                width="79"
                                height="22"
                                viewBox="0 0 79 22"
                                class="form-block__partner-icon"
                            />
                        </a>

                    </div>
                </div>
            </form>

            <form
                v-if="formData.length"
                :action="formData.redirect_url"
                method="post"
                class="callback-form" ref="form"
            >
                <input type="hidden" :name="formData.token">
                <input type="submit">
            </form>

        </div>
    </div>
</template>

<script>

import BaseSvgIcon from '@/components/base/BaseSvgIcon/';
import { mapGetters } from 'vuex';

export default {
    name: 'login',
    components: { BaseSvgIcon },
    data() {
        return {
            email: '',
            password: '',
            holder: {
                email: 'E-mail',
                password: 'Пароль'
            },
            formData: {}
        }
    },
    computed: {
        ...mapGetters('stateForm', ['statusForm'])
    },
    methods: {
        userLogin() {
            this.$validator.validateAll().then(result => {
                if (result) {
                    this.$store.dispatch('setLoader', true);
                    setTimeout(() => {
                        if (this.email === 'admin@mail.ru' && this.password === '123') {
                            console.log('this.$store.commit', this.$store.commit);
                            this.$store.commit('account/LOGIN');
                            this.$router.push('/profile');
                        } else {
                            alert('no')
                        }
                        this.$store.dispatch('setLoader', false);
                    }, 1000);
                } else {
                    console.log('Fields is empty:', result);
                }
            });
        },
        oldUserLogin() {
            this.$validator.validateAll().then(result => {
                if (result) {
                    this.$store.dispatch('setLoader', true);
                    axios.get('https://id.test.ipex.global/logout', {
                        withCredentials: true
                    })
                        .then(() => {
                            this.$store.dispatch('stateForm/changeStatusForm');
                            axios.get('https://id.test.ipex.global/api/token', {
                                withCredentials: true
                            })
                                .then((response) => {
                                    const token = response.data.token;
                                    axios.post('https://id.test.ipex.global/login',
                                        {
                                            _token: token,
                                            email: this.email,
                                            password: this.password
                                        },
                                        {
                                            headers: {
                                                'Accept': 'application/json',
                                                'X-Requested-With': 'XMLHttpRequest'
                                            },
                                            withCredentials: true
                                        }
                                    )
                                        .then((response) => {
                                            this.login();
                                            this.formData = response.data;
                                            this.$nextTick(() => this.$refs.form.submit());
                                            this.$router.push('/');
                                        })
                                        .catch(error => {
                                            console.log('%cПри вводе пароля произошла не предвиденная ошибка: ', 'color: red', error.response.data.message);
                                            console.log('%cПодробное описание ошибки: ', 'color: blue', error.response);
                                            this.$store.dispatch('stateForm/changeStatusForm');
                                        })
                                        .finally(() => this.$store.dispatch('setLoader', false));
                                })
                                .catch((error) => {
                                    this.$store.dispatch('stateForm/changeStatusForm');
                                    this.$store.dispatch('setLoader', false);
                                    console.log('На момент получения токена произошла ошибка: ', error.response);
                                });
                        })
                        .catch((err) => {
                            console.log('Во время logout\'a произошла ошибка: ', err);
                            this.$store.dispatch('stateForm/changeStatusForm');
                            this.$store.dispatch('setLoader', false);
                        });
                } else {
                    console.log('Fields is empty');
                }
            });
        },
        ...mapActions('account', ['login'])
    }
};

</script>
